import { BigNumber } from "ethers";
import { UbaFlow } from "../interfaces";
import { TokenRunningBalanceWithNetSend, UBAActionType, UBAFlowFee } from "./UBAFeeTypes";
import UBAConfig from "./UBAFeeConfig";
export declare function calculateHistoricalRunningBalance(flows: (UbaFlow & {
    incentiveFee: BigNumber;
})[], lastValidatedRunningBalance: BigNumber, lastValidatedIncentiveRunningBalance: BigNumber, lastNetRunningBalanceAdjustment: BigNumber, chainId: number, tokenSymbol: string, config: UBAConfig): TokenRunningBalanceWithNetSend;
export declare function getEventFee(amount: BigNumber, flowType: "inflow" | "outflow", lastRunningBalance: BigNumber, lastIncentiveBalance: BigNumber, chainId: number, config: UBAConfig): UBAFlowFee;
export declare function getDepositFee(amount: BigNumber, lastValidatedRunningBalance: BigNumber, lastValidatedIncentiveRunningBalance: BigNumber, chainId: number, config: UBAConfig): UBAFlowFee;
export declare function getRefundFee(amount: BigNumber, lastValidatedRunningBalance: BigNumber, lastValidatedIncentiveRunningBalance: BigNumber, chainId: number, config: UBAConfig): UBAFlowFee;
export declare const feeCalculationFunctionsForUBA: Record<UBAActionType, typeof getDepositFee | typeof getRefundFee>;
