"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UBA_CONFIG_ONCHAIN_SCHEMA = void 0;
var superstruct_1 = require("superstruct");
var CorrectRoutingRule = (0, superstruct_1.refine)((0, superstruct_1.string)(), "CorrectRoutingRule", function (value) {
    return /^\d+[-]\d+$/.test(value) || value === "default";
});
var NumericStringRule = (0, superstruct_1.refine)((0, superstruct_1.string)(), "NumericStringRule", function (value) { return /^\d+$/.test(value) || value === "default"; });
var NumericTupleRule = (0, superstruct_1.refine)((0, superstruct_1.array)(NumericStringRule), "NumericTupleRule", function (value) { return value.length === 2; });
exports.UBA_CONFIG_ONCHAIN_SCHEMA = (0, superstruct_1.object)({
    incentivePoolAdjustment: (0, superstruct_1.optional)((0, superstruct_1.record)(NumericStringRule, NumericStringRule)),
    ubaRewardMultiplier: (0, superstruct_1.optional)((0, superstruct_1.record)(NumericStringRule, NumericStringRule)),
    alpha: (0, superstruct_1.union)([
        (0, superstruct_1.object)({
            default: NumericStringRule,
        }),
        (0, superstruct_1.record)(CorrectRoutingRule, NumericStringRule),
    ]),
    gamma: (0, superstruct_1.record)(NumericStringRule, (0, superstruct_1.array)(NumericTupleRule)),
    omega: (0, superstruct_1.record)(NumericStringRule, (0, superstruct_1.array)(NumericTupleRule)),
    rebalance: (0, superstruct_1.union)([
        (0, superstruct_1.object)({
            default: (0, superstruct_1.object)({
                threshold_lower: (0, superstruct_1.optional)(NumericStringRule),
                threshold_upper: (0, superstruct_1.optional)(NumericStringRule),
                target_lower: (0, superstruct_1.optional)(NumericStringRule),
                target_upper: (0, superstruct_1.optional)(NumericStringRule),
            }),
        }),
        (0, superstruct_1.record)(NumericStringRule, (0, superstruct_1.object)({
            threshold_lower: (0, superstruct_1.optional)(NumericStringRule),
            threshold_upper: (0, superstruct_1.optional)(NumericStringRule),
            target_lower: (0, superstruct_1.optional)(NumericStringRule),
            target_upper: (0, superstruct_1.optional)(NumericStringRule),
        })),
    ]),
});
//# sourceMappingURL=superstructs.js.map