import type { Block, Provider } from "@ethersproject/abstract-provider";
import { CachingMechanismInterface } from "../interfaces";
type Opts = {
    latestBlockNumber?: number;
    latestBlockOffset?: number;
    blockRange?: number;
};
type BlockTimeAverage = {
    average: number;
    blockRange: number;
    timestamp: number;
};
export declare function averageBlockTime(provider: Provider, { latestBlockNumber, latestBlockOffset, blockRange }?: Opts): Promise<Pick<BlockTimeAverage, "average" | "blockRange">>;
export declare class BlockFinder {
    private readonly provider;
    private readonly blocks;
    constructor(provider: Provider, blocks?: Block[]);
    getBlockForTimestamp(timestamp: number | string): Promise<Block>;
    private getLatestBlock;
    private getBlock;
    private findBlock;
}
export declare function getCachedBlockForTimestamp(chainId: number, timestamp: number, blockFinder: BlockFinder, cache?: CachingMechanismInterface): Promise<number>;
export {};
